unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, Spin, Mask, ExtCtrls, jpeg;

type
  TRoSSocketizerMainForm = class(TForm)
    grpCurrentValues: TGroupBox;
    seCurrentDex: TSpinEdit;
    lblCurrentDex: TLabel;
    lblCurrentCC: TLabel;
    LblCurrentCD: TLabel;
    lblCurrentElemental: TLabel;
    seCurrentCD: TSpinEdit;
    seCurrentElemental: TSpinEdit;
    lblcurrentWeapon: TLabel;
    seCurrentMin: TSpinEdit;
    seCurrentMax: TSpinEdit;
    grpRing1: TGroupBox;
    cbSocketRing1: TCheckBox;
    seDexRing1: TSpinEdit;
    seCCRing1: TComboBox;
    seCDRing1: TSpinEdit;
    seElementalRing1: TSpinEdit;
    seMinRing1: TSpinEdit;
    seMaxRing1: TSpinEdit;
    cbDexRing1: TCheckBox;
    cbCCRing1: TCheckBox;
    cbCDRing1: TCheckBox;
    cbElementalRing1: TCheckBox;
    cbMinMaxRing1: TCheckBox;
    grpRing2: TGroupBox;
    cbSocketRing2: TCheckBox;
    seDexRing2: TSpinEdit;
    seCCRing2: TComboBox;
    seCDRing2: TSpinEdit;
    seElementalRing2: TSpinEdit;
    seMinRing2: TSpinEdit;
    seMaxRing2: TSpinEdit;
    cbDexRing2: TCheckBox;
    cbCCRing2: TCheckBox;
    cbCDRing2: TCheckBox;
    cbElementalRing2: TCheckBox;
    cbMinMaxRing2: TCheckBox;
    grpAmulet: TGroupBox;
    cbSocketRing3: TCheckBox;
    seDexRing3: TSpinEdit;
    seCCRing3: TComboBox;
    seCDRing3: TSpinEdit;
    seElementalRing3: TSpinEdit;
    seMinRing3: TSpinEdit;
    seMaxRing3: TSpinEdit;
    cbDexRing3: TCheckBox;
    cbCCRing3: TCheckBox;
    cbCDRing3: TCheckBox;
    cbElementalRing3: TCheckBox;
    cbMinMaxRing3: TCheckBox;
    MemoResult: TMemo;
    edtCurrentCC: TMaskEdit;
    edtCurrentAPS: TMaskEdit;
    lblCurrentAPS: TLabel;
    lblChangeDex1: TLabel;
    lblChangeCC1: TLabel;
    lblChangeCD1: TLabel;
    lblChangeElemental1: TLabel;
    lblChangeMinMax1: TLabel;
    lblChangeDex2: TLabel;
    lblChangeCC2: TLabel;
    lblChangeCD2: TLabel;
    lblChangeElemental2: TLabel;
    lblChangeMinMax2: TLabel;
    lblChangeDex3: TLabel;
    lblChangeCC3: TLabel;
    lblChangeCD3: TLabel;
    lblChangeElemental3: TLabel;
    lblChangeMinMax3: TLabel;
    Image1: TImage;
    lblSreenDPS: TLabel;
    procedure cbChangeSelectionClick(Sender: TObject);
    procedure BtnComputeClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure seInputChange(Sender: TObject);
  private
    { Private-Deklarationen }

    UseMatrix: Array[1..3,0..5] of Boolean;
    DamageMatrix: Array[0..5,0..5,0..5] of Single;

    BestCombo: Array[1..3] of Integer; // range of the vaues: 0..5

    procedure PrepareMatrix;
    procedure DoAllComputations;
    procedure SearchBestCombo;
    procedure OutputBestCombo;
    procedure OutputSimpleValues;
    function ComputeValue(a,b,c: Integer): Single;

    procedure ActivateGUI;

    function CalculateScreenDPS: Single;
    procedure OutputCurrentDPS;

    procedure DoAllStuff;
    function CheckInputs: Boolean;




  public
    { Public-Deklarationen }
  end;

const
    RingCC : Array[0..4] of Single = (4.0, 4.5, 5.0, 5.5, 6.0);
    AmulettCC : Array[0..4] of Single = (8.0, 8.5, 9.0, 9.5, 10.0);
    WeaponDamage : Array[0..3] of Single = (1.07, 1.08, 1.09, 1.10);

var
  RoSSocketizerMainForm: TRoSSocketizerMainForm;

implementation

{$R *.dfm}

procedure TRoSSocketizerMainForm.FormCreate(Sender: TObject);
begin
    DecimalSeparator := '.';
    ActivateGUI;
    DoAllStuff;
end;


procedure TRoSSocketizerMainForm.ActivateGUI;
begin
    seDexRing1      .enabled := cbSocketRing1.Checked and cbDexRing1.Checked;
    seCCRing1       .enabled := cbSocketRing1.Checked and cbCCRing1.Checked;
    seCDRing1       .enabled := cbSocketRing1.Checked and cbCDRing1.Checked;
    seElementalRing1.enabled := cbSocketRing1.Checked and cbElementalRing1.Checked;
    seMinRing1      .enabled := cbSocketRing1.Checked and cbMinMaxRing1.Checked;
    seMaxRing1      .enabled := cbSocketRing1.Checked and cbMinMaxRing1.Checked;

    seDexRing2      .enabled := cbSocketRing2.Checked and cbDexRing2.Checked;
    seCCRing2       .enabled := cbSocketRing2.Checked and cbCCRing2.Checked;
    seCDRing2       .enabled := cbSocketRing2.Checked and cbCDRing2.Checked;
    seElementalRing2.enabled := cbSocketRing2.Checked and cbElementalRing2.Checked;
    seMinRing2      .enabled := cbSocketRing2.Checked and cbMinMaxRing2.Checked;
    seMaxRing2      .enabled := cbSocketRing2.Checked and cbMinMaxRing2.Checked;

    seDexRing3      .enabled := cbSocketRing3.Checked and cbDexRing3.Checked;
    seCCRing3       .enabled := cbSocketRing3.Checked and cbCCRing3.Checked;
    seCDRing3       .enabled := cbSocketRing3.Checked and cbCDRing3.Checked;
    seElementalRing3.enabled := cbSocketRing3.Checked and cbElementalRing3.Checked;
    seMinRing3      .enabled := cbSocketRing3.Checked and cbMinMaxRing3.Checked;
    seMaxRing3      .enabled := cbSocketRing3.Checked and cbMinMaxRing3.Checked;

    cbDexRing1      .enabled := cbSocketRing1.Checked;
    cbCCRing1       .enabled := cbSocketRing1.Checked;
    cbCDRing1       .enabled := cbSocketRing1.Checked;
    cbElementalRing1.enabled := cbSocketRing1.Checked;
    cbMinMaxRing1   .enabled := cbSocketRing1.Checked;

    cbDexRing2      .enabled := cbSocketRing2.Checked;
    cbCCRing2       .enabled := cbSocketRing2.Checked;
    cbCDRing2       .enabled := cbSocketRing2.Checked;
    cbElementalRing2.enabled := cbSocketRing2.Checked;
    cbMinMaxRing2   .enabled := cbSocketRing2.Checked;

    cbDexRing3      .enabled := cbSocketRing3.Checked;
    cbCCRing3       .enabled := cbSocketRing3.Checked;
    cbCDRing3       .enabled := cbSocketRing3.Checked;
    cbElementalRing3.enabled := cbSocketRing3.Checked;
    cbMinMaxRing3   .enabled := cbSocketRing3.Checked;


    lblChangeDex1      .visible := seDexRing1      .enabled ;
    lblChangeCC1       .visible := seCCRing1       .enabled ;
    lblChangeCD1       .visible := seCDRing1       .enabled ;
    lblChangeElemental1.visible := seElementalRing1.enabled ;
    lblChangeMinMax1   .visible := seMinRing1      .enabled ;

    lblChangeDex2      .visible := seDexRing2      .enabled ;
    lblChangeCC2       .visible := seCCRing2       .enabled ;
    lblChangeCD2       .visible := seCDRing2       .enabled ;
    lblChangeElemental2.visible := seElementalRing2.enabled ;
    lblChangeMinMax2   .visible := seMinRing2      .enabled ;

    lblChangeDex3      .visible := seDexRing3      .enabled ;
    lblChangeCC3       .visible := seCCRing3       .enabled ;
    lblChangeCD3       .visible := seCDRing3       .enabled ;
    lblChangeElemental3.visible := seElementalRing3.enabled ;
    lblChangeMinMax3   .visible := seMinRing3      .enabled ;


end;

function TRoSSocketizerMainForm.CheckInputs: Boolean;
begin
    result := True;
    if seCurrentDex.Text = '' then result := False;
    if StrToFloatDef(edtCurrentCC.Text, -1) = -1 then result := False;
    if seCurrentCD.Text = '' then result := False;
    if seCurrentElemental.Text = '' then result := False;
    if seCurrentMin.Text = '' then result := False;
    if seCurrentMax.Text = '' then result := False;
    if edtCurrentAPS.Text = '' then result := False;

    if seDexRing1.Text = '' then result := False;
    if seCDRing1.Text = '' then result := False;  // CC not needed
    if seElementalRing1.Text = '' then result := False;
    if seMinRing1.Text = '' then result := False;
    if seMaxRing1.Text = '' then result := False;

    if seDexRing2.Text = '' then result := False;
    if seCDRing2.Text = '' then result := False;  // CC not needed
    if seElementalRing2.Text = '' then result := False;
    if seMinRing2.Text = '' then result := False;
    if seMaxRing2.Text = '' then result := False;

    if seDexRing3.Text = '' then result := False;
    if seCDRing3.Text = '' then result := False;  // CC not needed
    if seElementalRing3.Text = '' then result := False;
    if seMinRing3.Text = '' then result := False;
    if seMaxRing3.Text = '' then result := False;
end;

procedure TRoSSocketizerMainForm.seInputChange(Sender: TObject);
begin
    if CheckInputs then
        DoAllStuff;
end;

procedure TRoSSocketizerMainForm.cbChangeSelectionClick(Sender: TObject);
begin
    ActivateGUI;
    if CheckInputs then
        DoAllStuff;
end;


procedure TRoSSocketizerMainForm.DoAllStuff;
begin
    PrepareMatrix;
    DoAllComputations;
    SearchBestCombo;
    OutputBestCombo;

    CalculateScreenDPS;
    OutputCurrentDPS;
    OutputSimpleValues;
end;

procedure TRoSSocketizerMainForm.BtnComputeClick(Sender: TObject);
begin
    DoAllStuff;
end;


procedure TRoSSocketizerMainForm.PrepareMatrix;
var a,b,c: Integer;
begin
    UseMatrix[1,0] := NOT cbSocketRing1.Checked;
    UseMatrix[1,1] := cbSocketRing1.Checked AND cbDexRing1.Checked;
    UseMatrix[1,2] := cbSocketRing1.Checked AND cbCCRing1.Checked;
    UseMatrix[1,3] := cbSocketRing1.Checked AND cbCDRing1.Checked;
    UseMatrix[1,4] := cbSocketRing1.Checked AND cbElementalRing1.Checked;
    UseMatrix[1,5] := cbSocketRing1.Checked AND cbMinMaxRing1.Checked;

    UseMatrix[2,0] := NOT cbSocketRing2.Checked;
    UseMatrix[2,1] := cbSocketRing2.Checked AND cbDexRing2.Checked;
    UseMatrix[2,2] := cbSocketRing2.Checked AND cbCCRing2.Checked;
    UseMatrix[2,3] := cbSocketRing2.Checked AND cbCDRing2.Checked;
    UseMatrix[2,4] := cbSocketRing2.Checked AND cbElementalRing2.Checked;
    UseMatrix[2,5] := cbSocketRing2.Checked AND cbMinMaxRing2.Checked;

    UseMatrix[3,0] := NOT cbSocketRing3.Checked;
    UseMatrix[3,1] := cbSocketRing3.Checked AND cbDexRing3.Checked;
    UseMatrix[3,2] := cbSocketRing3.Checked AND cbCCRing3.Checked;
    UseMatrix[3,3] := cbSocketRing3.Checked AND cbCDRing3.Checked;
    UseMatrix[3,4] := cbSocketRing3.Checked AND cbElementalRing3.Checked;
    UseMatrix[3,5] := cbSocketRing3.Checked AND cbMinMaxRing3.Checked;

    for a := 0 to 5 do
      for b := 0 to 5 do
        for c := 0 to 5 do
          DamageMatrix[a,b,c] := 0;
end;


procedure TRoSSocketizerMainForm.SearchBestCombo;
var bestValue: Single;
    a,b,c: Integer;
begin
    bestValue := -1;
    for a := 0 to 5 do
      for b := 0 to 5 do
        for c := 0 to 5 do
          if UseMatrix[1,a]
             and UseMatrix[2,b]
             and UseMatrix[3,c]
          then
          begin
              if DamageMatrix[a,b,c] > bestValue then
              begin
                  bestValue := DamageMatrix[a,b,c];
                  BestCombo[1] := a;
                  BestCombo[2] := b;
                  BestCombo[3] := c;
              end;
          end;
end;



function TRoSSocketizerMainForm.CalculateScreenDPS: Single;
begin
    result := ((seCurrentMin.Value + seCurrentMax.Value) / 2)
             * (1 + (seCurrentDex.Value/100))
             * (1 + ((StrToFloat(edtCurrentCC.Text)/100)*(seCurrentCD.Value/100)) )
             * StrToFloat(edtCurrentAPS.Text)
             //* WeaponDamage[cbCurrentBonus.ItemIndex]
             ;
end;


function TRoSSocketizerMainForm.ComputeValue(a, b, c: Integer): Single;
var newDex, newCD, newElemental, newMin, newMax: Integer;
    newCC, avgDmg: Single;

begin
    // todo compute damage for position abc (range of abc: 0..5)
    newDex       := seCurrentDex.Value;
    newCC        := StrToFloat(edtCurrentCC.Text);
    newCD        := seCurrentCD.Value;
    newElemental := seCurrentElemental.Value;
    newMin       := seCurrentMin.Value;
    newMax       := seCurrentMax.Value;

    case a of
        0: ; // no change
        1: newDex := newDex - seDexRing1.Value ;
        2: newCC  := newCC - RingCC[seCCRing1.ItemIndex];
        3: newCD  := newCD - seCDRing1.Value;
        4: newElemental := newElemental - seElementalRing1.Value;
        5: begin
            newMin := newMin - seMinRing1.Value;
            newMax := newMax - seMaxRing1.Value;
        end;
    end;

    case b of
        0: ; // no change
        1: newDex := newDex - seDexRing2.Value ;
        2: newCC  := newCC - RingCC[seCCRing2.ItemIndex];
        3: newCD  := newCD - seCDRing2.Value;
        4: newElemental := newElemental - seElementalRing2.Value;
        5: begin
            newMin := newMin - seMinRing2.Value;
            newMax := newMax - seMaxRing2.Value;
        end;
    end;

    case c of
        0: ; // no change
        1: newDex := newDex - seDexRing3.Value ;
        2: newCC  := newCC - AmulettCC[seCCRing3.ItemIndex];
        3: newCD  := newCD - seCDRing3.Value;
        4: newElemental := newElemental - seElementalRing3.Value;
        5: begin
            newMin := newMin - seMinRing3.Value;
            newMax := newMax - seMaxRing3.Value;
        end;
    end;

    avgDmg := (newMax + newMin)/ 2;

    result := avgDmg
             * (1 + (newDex/100))
             * (1 + ((newCC/100)*(newCD/100)) )
             * (1 + newElemental/100);
end;

procedure TRoSSocketizerMainForm.DoAllComputations;
var a,b,c: Integer;
begin
    for a := 0 to 5 do
      for b := 0 to 5 do
          for c := 0 to 5 do
            DamageMatrix[a,b,c] := ComputeValue(a,b,c);
end;


procedure TRoSSocketizerMainForm.OutputBestCombo;
var lossRing1, lossRing2, lossRing3, lossComplete: Single;
    buffNeeded: Single;

begin
    MemoResult.Clear;
    MemoResult.Lines.Add('Best choice for maximum "Socketizer-DPS" is:');
    MemoResult.Lines.Add('-----------------------------------------------------');

    lossRing1 := (1 - (DamageMatrix[BestCombo[1], 0, 0] / DamageMatrix[0, 0, 0])) * 100;
    lossRing2 := (1 - (DamageMatrix[0, BestCombo[2], 0] / DamageMatrix[0, 0, 0])) * 100;
    lossRing3 := (1 - (DamageMatrix[0, 0, BestCombo[3]] / DamageMatrix[0, 0, 0])) * 100;

    case BestCombo[1] of
        0: MemoResult.Lines.Add(Format('Ring 1: untouched',[]));
        1: MemoResult.Lines.Add(Format('Ring 1: Replace Dexterity (losing %2.2f%% damage)',[lossRing1]));
        2: MemoResult.Lines.Add(Format('Ring 1: Replace CC (losing %2.2f%% damage)',[lossRing1]));
        3: MemoResult.Lines.Add(Format('Ring 1: Replace CD (losing %2.2f%% damage)',[lossRing1]));
        4: MemoResult.Lines.Add(Format('Ring 1: Replace Elemental (losing %2.2f%% damage)',[lossRing1]));
        5: MemoResult.Lines.Add(Format('Ring 1: Replace Min-Max (losing %2.2f%% damage)',[lossRing1]));
    end;
    case BestCombo[2] of
        0: MemoResult.Lines.Add(Format('Ring 2: untouched',[]));
        1: MemoResult.Lines.Add(Format('Ring 2: Replace Dexterity (losing %2.2f%% damage)',[lossRing2]));
        2: MemoResult.Lines.Add(Format('Ring 2: Replace CC (losing %2.2f%% damage)',[lossRing2]));
        3: MemoResult.Lines.Add(Format('Ring 2: Replace CD (losing %2.2f%% damage)',[lossRing2]));
        4: MemoResult.Lines.Add(Format('Ring 2: Replace Elemental (losing %2.2f%% damage)',[lossRing2]));
        5: MemoResult.Lines.Add(Format('Ring 2: Replace Min-Max (losing %2.2f%% damage)',[lossRing2]));
    end;
    case BestCombo[3] of
        0: MemoResult.Lines.Add('Amulet: untouched');
        1: MemoResult.Lines.Add(Format('Amulet: Replace Dexterity (losing %2.2f%% damage)',[lossRing3]));
        2: MemoResult.Lines.Add(Format('Amulet: Replace CC (losing %2.2f%% damage)',[lossRing3]));
        3: MemoResult.Lines.Add(Format('Amulet: Replace CD (losing %2.2f%% damage)',[lossRing3]));
        4: MemoResult.Lines.Add(Format('Amulet: Replace Elemental (losing %2.2f%% damage)',[lossRing3]));
        5: MemoResult.Lines.Add(Format('Amulet: Replace Min-Max (losing %2.2f%% damage)',[lossRing3]));
    end;

    lossComplete := (1 - (DamageMatrix[BestCombo[1], BestCombo[2], BestCombo[3]] / DamageMatrix[0, 0, 0])) * 100;
    buffNeeded := ((DamageMatrix[0, 0, 0] / DamageMatrix[BestCombo[1], BestCombo[2], BestCombo[3]]) - 1) * 100;
    MemoResult.Lines.Add('-----------------------------------------------------');
    MemoResult.Lines.Add(Format('Damage loss overall is %2.2f%%.',[lossComplete]));
    MemoResult.Lines.Add(Format('Your legendary gems should increase your damage by at least %2.2f%% to compensate this loss.',[buffNeeded]));

end;


procedure TRoSSocketizerMainForm.OutputCurrentDPS;
begin
    lblSreenDPS.Caption := (Format('ScreenDPS: %4.2f',[CalculateScreenDPS]));
end;


procedure TRoSSocketizerMainForm.OutputSimpleValues;
    function ComputeChange(ringIdx, affixIdx: Integer): Single;
    begin
        case ringIdx of
            1: result := (1 - (DamageMatrix[affixIdx, 0, 0] / DamageMatrix[0, 0, 0])) * 100;
            2: result := (1 - (DamageMatrix[0, affixIdx, 0] / DamageMatrix[0, 0, 0])) * 100;
            3: result := (1 - (DamageMatrix[0, 0, affixIdx] / DamageMatrix[0, 0, 0])) * 100;
        else
            result := 0;
        end;
    end;
begin
    lblChangeDex1.Caption       := Format('-%2.2f%%', [ComputeChange(1,1)]);
    lblChangeCC1.Caption        := Format('-%2.2f%%', [ComputeChange(1,2)]);
    lblChangeCD1.Caption        := Format('-%2.2f%%', [ComputeChange(1,3)]);
    lblChangeElemental1.Caption := Format('-%2.2f%%', [ComputeChange(1,4)]);
    lblChangeMinMax1.Caption    := Format('-%2.2f%%', [ComputeChange(1,5)]);

    lblChangeDex2.Caption       := Format('-%2.2f%%', [ComputeChange(2,1)]);
    lblChangeCC2.Caption        := Format('-%2.2f%%', [ComputeChange(2,2)]);
    lblChangeCD2.Caption        := Format('-%2.2f%%', [ComputeChange(2,3)]);
    lblChangeElemental2.Caption := Format('-%2.2f%%', [ComputeChange(2,4)]);
    lblChangeMinMax2.Caption    := Format('-%2.2f%%', [ComputeChange(2,5)]);

    lblChangeDex3.Caption       := Format('-%2.2f%%', [ComputeChange(3,1)]);
    lblChangeCC3.Caption        := Format('-%2.2f%%', [ComputeChange(3,2)]);
    lblChangeCD3.Caption        := Format('-%2.2f%%', [ComputeChange(3,3)]);
    lblChangeElemental3.Caption := Format('-%2.2f%%', [ComputeChange(3,4)]);
    lblChangeMinMax3.Caption    := Format('-%2.2f%%', [ComputeChange(3,5)]);
end;



end.
